<template>
  <div class="postcard-canvas-container">
    <canvas id="postcard-canvas" width="736px" height="518px"></canvas>
  </div>
</template>
<script>
//import { addPoint, getLine } from "./scripts/spline.js";

export default {
  data() {
    return {
      canvas: null,
      context: null,
      strokeStyle: "#000000",
      lineWidth: 2.0,
      pressure: 1.0,

      currentX: 0,
      currentY: 0,
      initialX: 0,
      initialY: 0,
      xOffset: 0,
      yOffset: 0,
      active: false,
      pts: [],
      splinePts: [],

      pointerdown: false,
      tool: "pencil",
      options: {
        smoothness: 0.5,
      },
    };
  },

  // we need more tools and an undo functionality:
  // https://stackoverflow.com/questions/17150610/undo-redo-for-paint-program-using-canvas
  // https://stackoverflow.com/questions/52332859/undo-redo-functionality-in-html-canvas#52332962
  mounted() {
    this.canvas = document.getElementById("postcard-canvas");
    this.context = this.canvas.getContext("2d");

    // optional pressure sensitivity for stylus enabled devices:

    this.canvas.addEventListener("pointerdown", this.drawStart, false);
    this.canvas.addEventListener("pointermove", this.draw, false);
    this.canvas.addEventListener("pointerup", this.drawEnd, false);

    this.canvas.addEventListener("touchstart", this.drawStart, false);
    this.canvas.addEventListener("touchend", this.drawEnd, false);
    this.canvas.addEventListener("touchmove", this.draw, false);

    this.canvas.addEventListener("mousedown", this.drawStart, false);
    this.canvas.addEventListener("mouseup", this.drawEnd, false);
    this.canvas.addEventListener("mousemove", this.draw, false);

    // initial settings for tool:
    this.context.strokeStyle = this.strokeStyle;
    this.context.lineWidth = this.lineWidth;
    this.context.lineCap = "round"; // set lineCap to round

    // initialize points array
    this.pts = [];
  },

  computed: {
    pointer() {
      return this.pointerdown;
    },
  },
  methods: {
    drawStart(e) {
      if (e.type === "touchstart") {
        this.initialX = e.touches[0].layerX;
        this.initialY = e.touches[0].layerY;
      } else {
        this.initialX = e.offsetX;
        this.initialY = e.offsetY;
      }

      this.active = true;

      this.context.beginPath();

      this.context.moveTo(this.initialX, this.initialY);
    },
    drawEnd() {
      this.active = false;
      //console.log(getLine(this.pts, null));
      console.log(this.splinePts);
      this.update();
    },
    draw(e) {
      if (this.active) {
        e.preventDefault();
        if (e.type === "touchstart") {
          this.initialX = e.touches[0].offsetX;
          this.initialY = e.touches[0].offsetY;
        } else {
          this.initialX = e.offsetX;
          this.initialY = e.offsetY;
        }

        if (e.type === "pointermove") {
          //console.log("pointertype: " + e.type);
          this.pressure = e.pressure;
          this.context.lineWidth = this.lineWidth * this.pressure;
          //this.pointerdown = e.pressure;
          //console.log("pressure: " + e.pressure);
        }

        // console.log("layer: " + e.layerX + " offset: " + e.offsetX);

        this.pts.push([this.initialX, this.initialY]);

        // addPoint(this.initialX, this.initialY);

        this.splinePts = getLine(this.pts, this.options);




        if (this.tool === "pencil") {
          //console.log("pointertype: " + e.type);
          this.context.lineTo(this.initialX, this.initialY);
          this.context.stroke();
          //this.drawSmoothLine(points);
        }
      }
    },
    update() {
      this.context.drawImage(this.canvas, 0, 0);
    },
    convertToImage() {
      let image = new Image();
      image.src = this.canvas.toDataURL("image/png");
      return image;
    },
    setTool(tool) {
      this.tool = tool;
    },
  },
};
</script>
